Eventemitter = require('events').EventEmitter
emitter = new Eventemitter()
child_process = require 'child_process'
_ = require 'lodash'
debug = require("debug")("omg-channels:bchannels")
helpers = require './channels-helpers'
iconvlite = require("iconv-lite")
fs = require 'fs'

running = true

bchannelsList = []#.extend({rateLimit: 10, notify: "always"})
getBchannelList = ->
  child_process.exec "getchannels -m -b 2>&1 | grep -v 'Channels found'", (error, stdout) => # omitted stderr
    stdout = stdout.toString()
    channels = stdout.split("\n")
    bchannelsLocal = {}
    channels = _.filter channels, (line) ->
      (line isnt "") and (line.indexOf("B-Channels and") is -1)
    # _.each channels, (bchannelName) ->
    #   bchannelsLocal[bchannelName] = {fullName: bchannelName}
    bchannelsList = channels

    # touch all files in /tmp to trigger update of currently running calls
    child_process.exec "touch /tmp/*"
    emitter.emit "changed"
getBchannelList()

bchannelConfigs = {}
watchDir = "/tmp/"
changedFiles = []
readNextChangedFile = ->
  # use first filename in changedFiles and remove it from array
  filename = changedFiles.shift()

  # check if file still exists before reading it
  fs.exists "#{watchDir}#{filename}", (exists) ->
    return unless exists

    fs.readFile "#{watchDir}#{filename}", (err, content) ->
      return if err
      decodedContent = iconvlite.decode(content, "utf-8")
      channelProperties = decodedContent.split("--")
      completeBchannelInfo = {}
      _.each channelProperties, (keyValObject) ->
        tempArray = keyValObject.split("=")
        newKey = tempArray[0]
        newVal = tempArray[1]
        try
          newKey = JSON.parse(newKey)
        try
          newVal = JSON.parse(newVal)
        completeBchannelInfo[newKey] = newVal

      bchannelName = completeBchannelInfo.bchannel

      if completeBchannelInfo.error is "none" or completeBchannelInfo.error is "active"
        completeBchannelInfo.active = true
      else
        completeBchannelInfo.active = false

      bchannelConfigs[bchannelName] = completeBchannelInfo
      emitter.emit "changed"

#start watching /tmp and scan changed files for changes
watcher = fs.watch watchDir, (event, filename) ->
  if (filename.lastIndexOf("BChannelState", 0) is 0) and (changedFiles.indexOf(filename) is -1)
    changedFiles.push filename
    throttledRead = ->
      readNextChangedFile()
    setTimeout throttledRead, 10
    debug "A file in /tmp changed #{filename}, #{event}"


activeCallsInterval = undefined

emitter.on "changed", ->

  localBchannels = []
  _.each bchannelsList, (bchan) ->
    bchanconfig = _.find bchannelConfigs, (conf) ->
      conf.bchannel is bchan

    if bchanconfig
      bchanconfig.runTime = helpers.calculateRuntime(bchanconfig.date)
    else
      bchanconfig =
        bchannel: bchan

    # bchanconfig.runTime = calculateRuntime(bchan.date) if bchan. bchan.date

    localBchannels.push bchanconfig


  # reset interval to send active calls runTime
  clearInterval activeCallsInterval if activeCallsInterval

  # get active calls
  activeCalls = _.filter bchannelConfigs, (conf) ->
    conf.active

  # if there are active calls, start a new interval for their runTime
  if _.size(activeCalls)
    activeCallsInterval = setInterval ->
      debug "sending active calls"
      _.each activeCalls, (conf) ->
        conf.runTime = helpers.calculateRuntime(conf.date)
      emitter.emit "new", localBchannels
    , 2000

  # debug JSON.stringify(localBchannels, null, 4)
  emitter.emit "new", localBchannels


bchannelsLib = emitter

bchannelsLib.start = ->
  return if running
  running = true
  debug "starting bchannels"
bchannelsLib.stop = ->
  return unless running
  running = false
  debug "stopping bchannels"

module.exports = bchannelsLib