#!/usr/bin/env coffee

Eventemitter = require('events').EventEmitter
isdn = new Eventemitter()
child_process = require 'child_process'
_ = require 'lodash'
debug = require("debug")("omg-channels:isdn")
tableParser = require("table-parser").parse
parseArgs = require "minimist"
async = require 'async'
glob = require "glob"
fs = require 'fs'

running = false

getIsdnStates = ->

  child_process.exec "getstates", (error, stdout, stderr) ->
    if error
      debug "error running getstates:", error
      return

    if stdout
      results = stdout.toString().split "\n"
      results = _.without results, ""
      _.each results, (oneState, index) ->
        #oneState === "ILID:11.a, L1:UP, L2:ESTABLISHED, CALLS:0"
        newState = {}
        oneStateSplit = oneState.split ", "
        #oneStateSplit === ["ILID:11.a", "L1:UP", "L2:ESTABLISHED", "CALLS:0"]
        _.each oneStateSplit, (statePart) ->
          #statePart === "ILID:11.a"
          statePartSplit = statePart.split ":"
          stateKey = statePartSplit[0] # == ILID
          stateValue = statePartSplit[1] # == 11.a
          newState[stateKey] = stateValue
        results[index] = newState
      debug "new isdn states: ", results
      isdn.emit "new", results

  # return

  # isdnProcesses = {}

  # # get all isdn processes
  # command = "ps -C isdn.prc l"
  # child_process.exec command, (error, stdout, stderr) ->
  #   debug error if error
  #   if stdout
  #     # create array of output lines
  #     parsedOut = stdout.toString()
  #     parsedOut = parsedOut.split("\n")

  #     # remove table header and last line
  #     parsedOut.shift()
  #     parsedOut.pop()

  #     # get parameters the process
  #     parsedOut = _.map parsedOut, (line) ->
  #       lineParts = line.split " "
  #       parameters = _.filter lineParts, (part) ->
  #         return _.startsWith part, "--" if part
  #       parameters = parseArgs parameters
  #       # debug "parameters of one line ", parameters
  #       return parameters

  #     _.each parsedOut, (parameters) ->
  #       ilid = "#{parameters.slot}.#{parameters['slot-index']}"
  #       isdnProcesses[ilid] = parameters

  #     async.map parsedOut, getLayerStates, (err, results) ->
  #       debug "Got isdn connection states", results
  #       isdn.emit "new", results
getIsdnStates()

isdn.getstates = ->
  # don't run when there are no subscribers
  return unless running
  debug "getting isdn connection states"
  getIsdnStates()

isdn.start = ->
  return if running
  running = true
  debug "starting isdn states"

isdn.stop = ->
  return unless running
  running = false
  debug "stopping isdn states"


setInterval isdn.getstates, 5000

module.exports = isdn
