// Generated by CoffeeScript 1.9.0
"use strict";
var aggConfig, config, exec, host, omg_gatelogs, pullSocket, zmq, _;

require("coffee-script");

config = require("/data/config.json");

aggConfig = config.agg;

zmq = require('zmq');

host = aggConfig.protocol + "://" + aggConfig.address + ":";

pullSocket = zmq.socket("pull");

pullSocket.bindSync("" + host + aggConfig.subscriberPoolPort);

omg_gatelogs = require("../lib/omg-gatelogs");

exec = require("child_process").exec;

_ = require("lodash");

describe("omg_gatelogs", function() {
  it('should listen for 0.1 minute when handed 0.1 as a string as an argument', function(done) {
    var onMessage, runTime;
    runTime = 0.1;
    this.timeout(1000 * 60 * runTime + 1000);
    omg_gatelogs.start(runTime);
    onMessage = function(data) {
      data = JSON.parse(data);
      data.producer.should.be.exactly("gatelogs");
      console.log(data);
      if (data.status === "started") {
        console.log("started successfuly");
      }
      if (data.data) {
        console.log(data.data);
      }
      if (data.status === "stopped") {
        done();
        pullSocket.removeListener("message", onMessage);
      }
    };
    return pullSocket.on("message", onMessage);
  });

  /* jshint ignore:start */
  return;
  describe("omg_gatelogs emit", function() {
    return it("should emit started", function(done) {
      var onStatus, outputCallback, startCallback, stoppedAlready;
      startCallback = function(err, data) {
        if (data) {
          console.log(data);
        }
        if (err) {
          throw err;
        }
      };
      outputCallback = function(err) {
        if (err) {
          throw err;
        }
      };
      stoppedAlready = false;
      onStatus = function(message) {
        var stop;
        console.log("gatelogs emitted: " + message);
        if (!stoppedAlready) {
          if (message === "stopped") {
            stoppedAlready = true;
          }
          stop = function() {
            return omg_gatelogs.stop();
          };
          if (message === "running") {
            stop();
          }
          if (message === "stopped") {
            omg_gatelogs.removeListener("status", onStatus);
            return done();
          }
        }
      };
      omg_gatelogs.on("status", onStatus);
      return omg_gatelogs.start(3, startCallback, outputCallback);
    });
  });
  describe("omg_gatelogs.start", function() {
    this.timeout(10000);
    return it("should start logger and receive data through a callback or through an emitter", function(done) {
      var dataThroughCallback, dataThroughemitter, onData, outcb, stcb;
      dataThroughCallback = false;
      dataThroughemitter = false;
      stcb = function() {
        var logIt;
        logIt = function() {
          return exec("logger testcode1234567");
        };
        return setTimeout(logIt, 1500);
      };
      outcb = function(err, data) {
        if (err) {
          throw err;
        }
        data.should.not.be.empty;
        if (data) {
          return _.each(data, function(line) {
            if (line.indexOf("testcode1234567") > -1) {
              return dataThroughCallback = true;
            }
          });
        }
      };
      onData = function(data) {
        data.should.not.be.empty;
        if (data) {
          _.each(data, function(line) {
            if (line.indexOf("testcode1234567") > -1) {
              return dataThroughemitter = true;
            }
          });
          if (dataThroughCallback && dataThroughemitter) {
            done();
            return omg_gatelogs.removeListener("data", onData);
          }
        }
      };
      omg_gatelogs.on("data", onData);
      return omg_gatelogs.start(2, stcb, outcb);
    });
  });
  describe("omg_gatelogs.getAllLogs", function() {
    return it("should get all loglines", function(done) {
      return omg_gatelogs.getAllLogs((function() {
        console.log("successfully started tail");
      }), function(err, data) {
        if (err) {
          throw err;
        }
        data.should.not.be.empty;
        data.should.be.array;
        return done();
      });
    });
  });
  describe("omg_gatelogs.getStatus", function() {
    return it("should not return an error", function(done) {
      return omg_gatelogs.getStatus(function(err, success) {
        if (err) {
          throw err;
        }
        success.should.be.equal("running");
        return done();
      });
    });
  });
  describe("omg_gatelogs.stop", function() {
    return it("should not return an error", function(done) {
      return omg_gatelogs.stop(function(err) {
        err.should.be.equal("regular stop");
        return done();
      });
    });
  });
  describe("omg_gatelogs.getStatus", function() {
    return it("should not return an error", function(done) {
      return omg_gatelogs.getStatus(function(err, success) {
        if (err) {
          throw err;
        }
        success.should.be.equal("stopped");
        return done();
      });
    });
  });
  return describe("omg_gatelogs.start", function() {
    this.timeout(5000);
    return it("should not crash if no callbacks were passed", function(done) {
      var onData;
      onData = function(data) {
        omg_gatelogs.removeListener("data", onData);
        return done();
      };
      omg_gatelogs.on("status", onData);
      exec("logger hu");
      return omg_gatelogs.start();
    });
  });
});
