
exec = require "child_process"
  .exec
_ = require "lodash"
debug = require("debug")("omg-scansipdestinations")

helper = require "omg-helperfunctions"

Producer = require "class_node_producer"

class Scansipdestinations extends Producer
  isRunning = false
  constructor: ->
    super "scansipdestinations"
    handleConfig = (err, status, res) =>
      if err
        debug err
        return

      res = res or []

      destinations = []

      _.each res, (channel, index) ->
        if not channel.bool_CfgValid #return if channel is deactivated
          debug "channel #{index} is deactivated"
          return
        if channel.struct_GateParams and channel.struct_GateParams.struct_CallProcTable
          addDestination = (rule) ->
            if not _.isObject(rule) or rule.string_sipDefaultGatewayIpAddress is ""
              return
            #return if the rule is connected to a messaging server,
            #which means that a different port (the one from the Dchannel) is used
            if rule.string_Destination is "FMS"
              return

            destination =
              ilidName: "#{channel.string_IlidSlot}.#{channel.string_IlidIndex}"
              address: rule.string_sipDefaultGatewayIpAddress,
              proto: rule.string_sipDefaultGatewayIpMode.toLowerCase(),
              port: rule.string_sipDefaultGatewayIpPort,
              info: rule.string_Description,
              disabled: rule.string_disabled,
              resolved: null

            destinations.push(destination)

          #has multiple rules
          if channel.struct_GateParams.struct_CallProcTable[0]
            _.each channel.struct_GateParams.struct_CallProcTable, (rule) ->
              addDestination rule
          #has just one rule
          else
            addDestination channel.struct_GateParams.struct_CallProcTable

      _.each destinations, (host, key) =>
        exec "./omgprobe.lua #{host.address} #{host.port} #{host.proto} --json", {cwd: __dirname + "/lua/"}, (error, stdout) => #, stderr
          try
            stdout = JSON.parse(stdout)
          catch e
            logger.error "Could not parse output of omgprobe.lua; #{e}"

          destinations[key].resolved = stdout.resolved
          @sendData destinations

    @start = =>
      @sendData {}, true
      @debug "starting"

      requestObject =
        producer: "configurator"
        action: "get"
        args: ["config.lua struct_DChannel"]

      @requestData requestObject, handleConfig

    @stop = =>
      isRunning = false


module.exports = new Scansipdestinations()



return




handleConfig = (res) ->
  res = helper.zmqPureMessage(res)
  res = res.outputMessage
  destinations = []
  _.each res, (channel, index) ->
    return if not channel.bool_CfgValid #return if channel is deactivated
    if channel.struct_GateParams and channel.struct_GateParams.struct_CallProcTable
      _.each channel.struct_GateParams.struct_CallProcTable, (rule) ->
        return if not _.isObject(rule) or rule.string_sipDefaultGatewayIpAddress is ""

        destination =
          ilidName: "#{channel.string_IlidSlot}.#{channel.string_IlidIndex}"
          address: rule.string_sipDefaultGatewayIpAddress,
          proto: rule.string_sipDefaultGatewayIpMode.toLowerCase(),
          port: rule.string_sipDefaultGatewayIpPort,
          info: rule.string_Description,
          disabled: rule.string_disabled,
          resolved: null

        destinations.push(destination)

  _.each destinations, (host, key) ->
    exec "./omgprobe.lua #{host.address} #{host.port} #{host.proto} --json", {cwd: __dirname + "/lua/"}, (error, stdout) -> #, stderr
      stdout = JSON.parse(stdout)
      destinations[key].resolved = stdout.resolved
      sendData destinations

requestSocket.on "message", handleConfig

exports.start = () ->
  sendData {}, true
  requestObject =
    producer: "configurator"
    action: "get"
    args: ["config.lua struct_DChannel"]

  requestSocket.send JSON.stringify(requestObject)
  # configurator.get "config.lua struct_DChannel", undefined, handleConfig



# /*
#  * omg-scansipdestinations
#  *
#  * Copyright (c) 2015 Ferrari electronic AG
#  *
#  */

# 'use strict';

# var logger = require("omg-logger");
# var _ = require("lodash");
# var exec = require('child_process').exec;


# function customFilter(object, result) {
#     if (object.hasOwnProperty('string_sipDefaultGatewayIpAddress') && object.string_sipDefaultGatewayIpAddress !== "") {
#         result.push({
#             address: object.string_sipDefaultGatewayIpAddress,
#             proto: object.string_sipDefaultGatewayIpMode.toLowerCase(),
#             port: object.string_sipDefaultGatewayIpPort,
#             info: object.string_Description,
#             disabled: object.string_disabled,
#             resolved: null
#         });
#     }
#     for (var i = 0; i < Object.keys(object).length; i++) {
#         if (typeof object[Object.keys(object)[i]] === "object") {
#             if (object[Object.keys(object)[i]].bool_CfgValid !== false) {
#                 customFilter(object[Object.keys(object)[i]], result);
#             }
#         }
#     }
# }

# exports.start = function(startCallback, outputCallback) { //this function has a name!
#     logger.info("scan starting");
#     startCallback();

#     exec("./config2json.lua", {
#         cwd: __dirname + "/lua/"
#     }, function(error, stdout) { // , stderr
#         if (error) {
#             logger.error(error.message);
#             startCallback(error);
#             return;
#         }
#         var config;
#         var data = {};
#         var res = [],
#             unique;
#         try {
#             config = JSON.parse(stdout);
#         } catch (e) {
#             logger.error("no /data/config.lua ?\n\n\n");
#         }

#         customFilter(config, res);

#         unique = _.uniq(res, function(rule) { // , key , res
#             return rule.address + rule.proto + rule.port + rule.disabled + rule.info;
#         });

#         _.each(unique, function(rule) {
#             var propertyName = (rule.address + rule.proto + rule.port + rule.disabled + rule.info);
#             data[propertyName] = rule;
#         });
#         outputCallback(null, data);

#         _.each(data, function(host, key) {
#             exec("./omgprobe.lua " + host.address + " " + host.port + " " + host.proto + " --json", {
#                 cwd: __dirname + "/lua/"
#             }, function(error, stdout) { //, stderr
#                 stdout = JSON.parse(stdout);
#                 data[key].resolved = stdout.resolved;
#                 outputCallback(null, data);
#             });
#         });
#     });
# };