// Generated by CoffeeScript 1.9.0
"use strict";
var Producer, Testcall, call, checkFreePort, debug, exec, ko, logs, removeOldCallLogs, shell, testcallFolder, _,
  __bind = function(fn, me){ return function(){ return fn.apply(me, arguments); }; },
  __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
  __hasProp = {}.hasOwnProperty;

exec = require("child_process").exec;

_ = require("lodash");

shell = require("shelljs");

ko = require("knockout");

debug = require("debug")("omg-testcall");

Producer = require("class_node_producer");

call = require('./call');

logs = require('./logs');

testcallFolder = "/tmp/testcall";

if (!shell.test("-e", testcallFolder)) {
  shell.mkdir(testcallFolder);
}

shell.cp("-f", __dirname + "/files/*", testcallFolder + "/");

removeOldCallLogs = function(asyncCallback) {
  return exec("rm -f " + testcallFolder + "/*.log", function(e, out) {
    return asyncCallback(e, out);
  });
};

checkFreePort = function(asyncCallback) {
  return freeport(function(error, aFreePort) {
    return asyncCallback(error, aFreePort);
  });
};

Testcall = (function(_super) {
  __extends(Testcall, _super);

  function Testcall() {
    this.start = __bind(this.start, this);
    var callRunning, statusSender;
    Testcall.__super__.constructor.call(this, "testcall");
    this.gatelogsRunning = logs.running;
    callRunning = call.running;
    this.callIsWaiting = false;
    callRunning.subscribe(function(val) {
      if (!val) {
        return logs.stop();
      }
    });
    this.gatelogsOrCallRunning = ko.computed({
      read: (function(_this) {
        return function() {
          if (_this.gatelogsRunning() || callRunning()) {
            return true;
          } else {
            return false;
          }
        };
      })(this),
      deferEvaluation: true
    });
    statusSender = ko.computed((function(_this) {
      return function() {
        if (callRunning()) {
          _this.sendStatus("running");
          debug("Call is running");
        } else {
          _this.sendStatus("stopped");
        }
        if (!_this.gatelogsOrCallRunning()) {
          _this.sendStatus("stopped");
          return debug("Log and call not running");
        }
      };
    })(this));
    logs.on("data", (function(_this) {
      return function(data) {
        return _this.sendData(data);
      };
    })(this));
    call.on("finished", function() {
      debug("call finished, stopping logs");
      return logs.stop();
    });
  }

  Testcall.prototype.start = function(callObject) {
    var retryWhenAllStopped, startWhenLogsAreRunning;
    debug("starting call");
    if (this.gatelogsOrCallRunning()) {
      if (this.callIsWaiting) {
        return;
      } else {
        this.callIsWaiting = true;
      }
      retryWhenAllStopped = this.gatelogsOrCallRunning.subscribe((function(_this) {
        return function(stillRunning) {
          if (!stillRunning) {
            debug("Previous call and gatelogs stopped. Running new call");
            retryWhenAllStopped.dispose();
            _this.start(callObject);
            return _this.callIsWaiting = false;
          }
        };
      })(this));
      this.sendData(["Waiting for previous call to finish."]);
      debug("Waiting for previous call to finish.");
      logs.stop();
      return;
    }
    this.sendStatus("started");
    debug("starting logs and call");
    if (this.gatelogsRunning()) {
      call.start(callObject);
    } else {
      startWhenLogsAreRunning = this.gatelogsRunning.subscribe(function(val) {
        if (val) {
          startWhenLogsAreRunning.dispose();
          return call.start(callObject);
        }
      });
    }
    return logs.start();
  };

  Testcall.prototype.stop = function(callback) {
    logs.stop();
    return call.stop();
  };

  return Testcall;

})(Producer);

module.exports = new Testcall();
